	volVectorField gradGamma
    (
        IOobject
        (
            "gradGamma",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        fvc::grad(gamma)	//to diffusive
		//fvc::lsGrad(gamma)
		//fvc::grad(pos(gamma-0.5))
		//0.5*(fvc::grad(pos(gamma-0.49999))+fvc::grad(neg(gamma-0.49999)))
		//fvc::grad(neg(gamma-0.5))
    );
/*
	volScalarField sharp
    (
        IOobject
        (
            "sharp",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        //pos(gamma-0.5)
		//1-2*mag(0.5-gamma)
		1-mag(0.5-gamma)
    );
*/
/*
	volVectorField ngradGamma
    (
        IOobject
        (
            "ngradGamma",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        gradGamma/(mag(gradGamma) + interface.deltaN())
    );

	surfaceVectorField gradGammaf
    (
        IOobject
        (
            "gradGammaf",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        fvc::interpolate(gradGamma)
    );

	surfaceVectorField nHatfv
    (
        IOobject
        (
            "nHatfv",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        gradGammaf/(mag(gradGammaf) + interface.deltaN())
		//interface.correctContactAngle(nHatfv.boundaryField())
    );
    
	surfaceScalarField nHatf
    (
        IOobject
        (
            "nHatf",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        //interface.nHatf()
		nHatfv & mesh.Sf()
    );

	volScalarField K
    (
        IOobject
        (
            "K",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        -fvc::div(nHatf)
    );
	
	if (runTime.outputTime())
			{
			  	K.write();
			};

	*/
	
	volScalarField weight
	(
	IOobject
	(
	"weight",
	runTime.timeName(),
	mesh,
	IOobject::NO_READ,
	IOobject::NO_WRITE
	),
	//(1-max(gamma,0.5))
	//1-(pos(gamma-0.5)) //returns 1 if gamma > 0.5 and 0 otherwise
	(1-gamma)
	);
	//bubbleCenter
	vector Cb0 = Cb;
	dimensionedVector Cb = fvc::domainIntegrate(weight*mesh.C())/fvc::domainIntegrate(weight);
	// oder so:
	//dimensionedVector Cb 		  = gSum((weight.internalField())*mesh.C().internalField()*mesh.V())/gSum((weight.internalField())*mesh.V());
	
	//risingVelocity
	dimensionedVector Ub = fvc::domainIntegrate(weight*U)/fvc::domainIntegrate(weight);
	dimensionedVector dUF
    (
        "dUF",
        dimVelocity,
        (Cb-Cb0)/runTime.deltaT0().value()
    );	
	dimensionedScalar bubbleVolume = sum((1-gamma)*mesh.V());//sum(weight*mesh.V());
	dimensionedScalar bubbleSurfA  = sum(mag(gradGamma)*mesh.V());
	scalar diffEmptyPatches=0.1;
	dimensionedScalar bubCircuari = sqrt(4/mathematicalConstant::pi*bubbleVolume*diffEmptyPatches)*mathematicalConstant::pi/bubbleSurfA;

	//volScalarField::GeometricBoundaryField d = nearWallDist(mesh).y(); 
	//!!!nearWallDist funktioniert nur fuer Walls!!!!
	/*
	const fvPatchList& patches = mesh.boundary();

	forAll (patches, patchI)
            {
                if (isType<wallFvPatch>(patches[patchI])) // für empty ist mesh.Cf() empty! also anhand der WallPatches
                {

				const vectorField& faceCentres = mesh.Cf().boundaryField()[patchI];
				const vectorField& faceDirect  = mesh.Sf().boundaryField()[patchI];
	 
	 			scalar maxX=max(faceCentres.component(0)*pos(faceDirect.component(0)));
	 			scalar minX=min(faceCentres.component(0)*neg(faceDirect.component(0)));
			 	scalar maxY=max(faceCentres.component(1)*pos(faceDirect.component(1)));
	 			scalar minY=min(faceCentres.component(1)*neg(faceDirect.component(1)));
	 			scalar maxZ=max(faceCentres.component(2)*pos(faceDirect.component(2)));
	 			scalar minZ=min(faceCentres.component(2)*neg(faceDirect.component(2)));
				scalar diffX=maxX-minX;
				scalar diffY=maxY-minY;				
				scalar diffZ=maxZ-minZ;

				//Info<< "Abstand= " << min(diffX,min(diffY,diffZ)) << endl; 
				Info<< "min= " << faceCentres << " " << minY << " " << minZ  << endl; 
				Info<< "max= " << maxX << " " << maxY << " " << maxZ  << endl; 
				Info<< "Abstand= " << diffX << " " << diffY << " " << diffZ  << endl; 
				}
			*/
            
	 

	Info<< "Ubity = " << Ub.value() << endl;
	Info<< "bubbleCentroid = " << Cb.value() << endl;
	Info<< "bubbleVolume = " << bubbleVolume.value() << endl;
	Info<< "bubbleSurfArea = " << bubbleSurfA.value() << endl;
	Info<< "bubbleSurfBrea = isoSurface=0.5 Paraview"<< endl;
	Info<< "bubCircuari = " << bubCircuari << endl;
	Info<< "with Distance of the empty patches = " << bubCircuari << endl;


